#include "c4d_baseplugin.h"
#include "c4d_memory.h"

BaseData::BaseData(void) 
{
}

BaseData::~BaseData(void) 
{
}

void BaseData::Destructor(void) 
{
	BaseData	*_this;
	
	_this = this;
	gDelete( _this );
}

#define Call(fnc) (this->*C4DOS.Ge->fnc)

void* BasePlugin::GetPluginStructure()
{
	return Call(GetPluginStructure)();
}

LONG BasePlugin::GetInfo()
{
	return Call(GetInfo)();
}

Filename BasePlugin::GetFilename()
{
	return Call(GetFilename)();
}

LONG BasePlugin::GetID()
{
	return Call(GetID)();
}

BasePlugin* FindPlugin(LONG id, PLUGINTYPE type)
{
	return (*C4DOS.Ge->FindPlugin)(id, type);
}

void RemovePlugin(BasePlugin *plug)
{
	(*C4DOS.Ge->RemovePlugin)(plug);
}

BasePlugin*	GetFirstPlugin()
{
	return (*C4DOS.Ge->GetFirstPlugin)();
}

Bool FilterPluginList(AtomArray &arr, PLUGINTYPE type, Bool sortbyname)
{
	return (*C4DOS.Ge->FilterPluginList)(arr, type, sortbyname);
}

void BuildGlobalTagPluginContainer(BaseContainer *plugincontainer,LONG *id)
{
	(*C4DOS.Ge->BuildGlobalTagPluginContainer)(plugincontainer,id);
}

LONG ResolveGlobalTagPluginContainer(LONG *id)
{
	return (*C4DOS.Ge->ResolveGlobalTagPluginContainer)(id);
}

// private
Filename *GetLocalFilename()
{
	return (*C4DOS.Ge->GetLocalFilename)();
}

// private
BasePlugin *CreatePluginEntry(const String &fn, BasePlugin *bp)
{
	return (*C4DOS.Ge->CreatePluginEntry)(fn, bp);
}

// private
void SetLocalHierarchy(BasePlugin *parent, BasePlugin *pred)
{
	C4DOS.Ge->SetLocalHierarchy(parent, pred);
}

